#ifndef MFE_FILTER_HH
#define MFE_FILTER_HH

#include "mfe_answer.hh"
#include "mfe_answer_v4.hh"
#include "hishape_answer_v4.hh"

struct Mfe_Filter {

  static int thresh;

  static bool ok(int mfe)
  {
    return mfe <= thresh;
  }
};

#ifdef GAPC_MOD_TRANSLATION_UNIT

int Mfe_Filter::thresh = 1000000;

#endif

/*
inline bool in_mfe_thresh(int t)
{
  return Mfe_Filter().ok(t);
}

template <typename T>
inline bool in_mfe_thresh(const std::pair<int, T> &t)
{
  return Mfe_Filter().ok(t.first);
}
*/

template <typename T>
inline bool mfe_thresh(const T &x)
{
  return Mfe_Filter().ok(x.first.second.energy);
  //return true;
}

inline bool mfe_thresh(std::pair<Rope, mfeanswer>  &x)  // IMPORTANT with mfeanswer    // hishapeanswer_v4 ==> Rope, mfeanswer_v4 => mfeanswer
{
  // only when x.second.energy is smaller than 0, then further
  // std::cout << x.first.energy << ", " << x.second.energy << ",  " << x.second.hi_rope << ",  " << x.second.pp << std::endl;
  return Mfe_Filter().ok(x.second.energy);
}

inline bool mfe_thresh(std::pair<Rope, mfeanswer_v4>  &x)  // IMPORTANT with mfeanswer    // hishapeanswer_v4 ==> Rope, mfeanswer_v4 => mfeanswer
{
  return Mfe_Filter().ok(x.second.energy);
}

inline bool mfe_thresh(std::pair<hishapeanswer_v4, mfeanswer>  &x)  // IMPORTANT with mfeanswer    // hishapeanswer_v4 ==> Rope, mfeanswer_v4 => mfeanswer
{
  return Mfe_Filter().ok(x.second.energy);
}

#endif
